Unit AV19C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

procedure AV19C(N :Integer; var SX :Array of Complex; INCX :Integer;
                var SY :Array of Complex; INCY :Integer; C :Complex;
                S :Complex; var IERR :Integer);

implementation

procedure AV19C(N :Integer; var SX :Array of Complex; INCX :Integer;
                var SY :Array of Complex; INCY :Integer; C :Complex;
                S :Complex; var IERR :Integer);
var
I,IX,IY :Integer;
X :Real;
STEMP :Complex;
LC,LS :Boolean;
label
_10,_20,_30,_40,_60;
begin

{   PMEHEHE OCKOO BPAEH BEHCA }
X  := 0.0;

{   POBEPKA PABHOCT AAH APAMETPA N }
if ( N  <=  0 ) 
 then goto _40;
IERR  := 0;
LC  := ( Creal(C) =  1.0 ) and (  Aimag(C) =  0.0 );
LS  := ( Creal(S) =  1.0 ) and (  Aimag(S) =  0.0 );
if ( LC  ) and (  LS ) 
 then goto _60;
if ( INCX  =  1 ) and (  INCY  =  1 ) 
 then goto _20;
IX  := 1 + ((INCX - Abs(INCX)) div 2)*(1 - N);
IY  := 1 + ((INCY - Abs(INCY)) div 2)*(1 - N);
for I:=1 to N do
 begin
  STEMP  := AddC(MulC(C,SX[IX-1]),MulC(S,SY[IY-1]));
  SY[IY-1] := SubC(MulC(C,SY[IY-1]),MulC(S,SX[IX-1]));
  SX[IX-1] := STEMP;
  IX  := IX + INCX;
  IY  := IY + INCY;
_10:
 end;
goto _60;
_20:
for I:=1 to N do
 begin
  STEMP  := AddC(MulC(C,SX[I-1]),MulC(S,SY[I-1]));
  SY[I-1] := SubC(MulC(C,SY[I-1]),MulC(S,SX[I-1]));
  SX[I-1] := STEMP;
_30:
 end;
goto _60;
_40:
IERR  := 65;
UTAV10(IERR,30);
goto _60;
_60:
end;

end.
